import { px2hd } from '../util';
export interface ComponentContext {
    px2hd: typeof px2hd;
    [key: string]: any;
}
declare class Component<T = any> {
    props: T;
    state: any;
    context: ComponentContext;
    refs: {
        [key: string]: any;
    };
    updater: any;
    children: JSX.Element;
    container: any;
    animate: boolean;
    constructor(props: any, context?: any, updater?: any);
    willMount(): void;
    didMount(): void;
    willReceiveProps(_props: T): void;
    willUpdate(): void;
    didUpdate(): void;
    render(): any;
    didUnmount(): void;
    setState(partialState: any, callback?: () => void): void;
    forceUpdate(): void;
    setAnimate(animate: boolean): void;
}
export default Component;
