import Component from '../base/component';
import Layout from '../base/layout';
import Animation from './animation';
interface ChartProps {
    context?: CanvasRenderingContext2D;
    pixelRatio?: number;
    width?: number | string;
    height?: number | string;
    padding?: number | string | (number | string)[];
    animate?: boolean;
    children?: any;
    px2hd?: any;
    theme?: any;
    style?: any;
}
interface IF2Canvas {
    container: any;
}
declare class Canvas extends Component<ChartProps> implements IF2Canvas {
    canvas: any;
    animation?: Animation;
    layout: Layout;
    theme: any;
    private _ee;
    constructor(props: ChartProps);
    renderComponents(components: Component[]): void;
    update(nextProps: ChartProps): void;
    draw(): void;
    play(): void;
    render(): any;
    destroy(): void;
    on(type: string, listener: any): void;
    emit(type: string, event?: any): void;
    off(type: string, listener?: any): void;
}
export default Canvas;
