import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { jsx } from '../../../jsx';
export default (function (props) {
  var coord = props.coord,
      records = props.records;
  var center = coord.center;
  return jsx("group", null, records.map(function (record) {
    var key = record.key,
        children = record.children;
    return jsx("group", {
      key: key
    }, children.map(function (item) {
      var key = item.key,
          xMin = item.xMin,
          xMax = item.xMax,
          yMin = item.yMin,
          yMax = item.yMax,
          color = item.color,
          shape = item.shape;
      return jsx("sector", {
        key: key,
        attrs: _objectSpread({
          x: center.x,
          y: center.y,
          fill: color,
          startAngle: xMin,
          endAngle: xMax,
          r0: yMin,
          r: yMax
        }, shape),
        animation: {
          // appear: {
          //   easing: 'linear',
          //   duration: 450,
          //   property: ['y', 'height'],
          //   start: {
          //     y: yMax,
          //     height: 0,
          //   },
          // },
          update: {
            easing: 'linear',
            duration: 450,
            property: ['x', 'y', 'startAngle', 'endAngle', 'r0', 'r']
          }
        }
      });
    }));
  }));
});