import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { jsx } from '../../jsx';
export default (function (props) {
  var records = props.records;
  return jsx("group", null, records.map(function (record) {
    var key = record.key,
        children = record.children;
    return jsx("group", {
      key: key
    }, children.map(function (item) {
      var x = item.x,
          y = item.y,
          size = item.size,
          color = item.color,
          shape = item.shape;
      return jsx("circle", {
        attrs: _objectSpread({
          x: x,
          y: y,
          r: (size !== null && size !== void 0 ? size : 4) / 2,
          fill: color,
          stroke: '#fff'
        }, shape),
        animation: {
          appear: {
            easing: 'linear',
            duration: 450
          },
          update: {
            easing: 'linear',
            duration: 450,
            property: ['x', 'y', 'r', 'fill']
          }
        }
      });
    }));
  }));
});