import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { jsx } from '../../jsx';
import Component from '../../base/component';
import { isFunction } from '@antv/util';
export default (function (View) {
  return /*#__PURE__*/function (_Component) {
    _inherits(Tooltip, _Component);

    var _super = _createSuper(Tooltip);

    function Tooltip(props) {
      var _this;

      _classCallCheck(this, Tooltip);

      _this = _super.call(this, props);
      _this.state = {
        records: null
      };
      return _this;
    }

    _createClass(Tooltip, [{
      key: "didMount",
      value: function didMount() {
        this._initEvent();
      }
    }, {
      key: "_initEvent",
      value: function _initEvent() {
        var _this2 = this;

        var context = this.context,
            props = this.props;
        var canvas = context.canvas;
        var _props$triggerOn = props.triggerOn,
            triggerOn = _props$triggerOn === void 0 ? 'press' : _props$triggerOn,
            _props$triggerOff = props.triggerOff,
            triggerOff = _props$triggerOff === void 0 ? 'pressend' : _props$triggerOff,
            _props$alwaysShow = props.alwaysShow,
            alwaysShow = _props$alwaysShow === void 0 ? false : _props$alwaysShow;
        canvas.on(triggerOn, function (ev) {
          var points = ev.points;

          _this2.show(points[0]);
        });
        canvas.on(triggerOff, function (_ev) {
          if (!alwaysShow) {
            _this2.hide();
          }
        });
      }
    }, {
      key: "show",
      value: function show(point) {
        var props = this.props;
        var chart = props.chart,
            onChange = props.onChange;
        var records = chart.getSnapRecords(point);
        this.setState({
          records: records
        });

        if (isFunction(onChange)) {
          onChange(records);
        }
      }
    }, {
      key: "hide",
      value: function hide() {
        this.setState({
          records: null
        });
      }
    }, {
      key: "render",
      value: function render() {
        var props = this.props,
            state = this.state;
        var visible = props.visible;

        if (visible === false) {
          return null;
        }

        return jsx(View, _objectSpread(_objectSpread({}, props), state));
      }
    }]);

    return Tooltip;
  }(Component);
});