import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { isArray } from '@antv/util';
import Base from './base';

var Rect = /*#__PURE__*/function (_Base) {
  _inherits(Rect, _Base);

  var _super = _createSuper(Rect);

  function Rect() {
    var _this;

    _classCallCheck(this, Rect);

    _this = _super.apply(this, arguments);
    _this.type = 'rect';
    return _this;
  }

  _createClass(Rect, [{
    key: "update",
    value: function update(option) {
      _get(_getPrototypeOf(Rect.prototype), "update", this).call(this, option);

      var left = this.left,
          top = this.top,
          right = this.right,
          bottom = this.bottom;
      var x = [left, right];
      var y = [bottom, top];
      this.x = x;
      this.y = y;
      return this;
    }
  }, {
    key: "_zoomVal",
    value: function _zoomVal(val, func) {
      return isArray(val) ? val.map(function (v) {
        return func(v);
      }) : func(val);
    }
  }, {
    key: "convertPoint",
    value: function convertPoint(point) {
      var transposed = this.transposed,
          x = this.x,
          y = this.y;
      var xDim = transposed ? 'y' : 'x';
      var yDim = transposed ? 'x' : 'y';
      return {
        x: this._zoomVal(point[xDim], function (v) {
          return x[0] + (x[1] - x[0]) * v;
        }),
        y: this._zoomVal(point[yDim], function (v) {
          return y[0] + (y[1] - y[0]) * v;
        })
      };
    }
  }, {
    key: "invertPoint",
    value: function invertPoint(point) {
      var _ref;

      var transposed = this.transposed,
          x = this.x,
          y = this.y;
      var xDim = transposed ? 'y' : 'x';
      var yDim = transposed ? 'x' : 'y';
      return _ref = {}, _defineProperty(_ref, xDim, this._zoomVal(point.x, function (v) {
        return (v - x[0]) / (x[1] - x[0]);
      })), _defineProperty(_ref, yDim, this._zoomVal(point.y, function (v) {
        return (v - y[0]) / (y[1] - y[0]);
      })), _ref;
    }
  }]);

  return Rect;
}(Base);

export default Rect;