import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
var _excluded = ["type"];
import { Rect, Polar } from '../coord';
import { isString, isFunction } from '@antv/util';
var coordMap = {
  rect: Rect,
  polar: Polar
};

var CoordMixin = /*#__PURE__*/function () {
  function CoordMixin() {
    _classCallCheck(this, CoordMixin);
  }

  _createClass(CoordMixin, [{
    key: "createCoord",
    value: function createCoord(cfg, layout) {
      if (isString(cfg)) {
        cfg = {
          type: coordMap[cfg] || Rect
        };
      } else if (isFunction(cfg)) {
        cfg = {
          type: cfg
        };
      }

      var coordCfg = _objectSpread(_objectSpread({
        // 默认直角坐标系
        type: Rect
      }, layout), cfg);

      var type = coordCfg.type,
          option = _objectWithoutProperties(coordCfg, _excluded);

      var coord = new type(option);
      return coord;
    }
  }, {
    key: "updateCoord",
    value: function updateCoord(cfg, layout) {
      return this.createCoord(cfg, layout);
    }
  }]);

  return CoordMixin;
}();

export default CoordMixin;