var axis = {
  labelOffset: '15px',
  line: {
    stroke: '#E8E8E8',
    lineWidth: '1px'
  },
  label: {
    fill: '#808080',
    fontSize: '20px'
  },
  grid: {
    stroke: '#E8E8E8',
    lineWidth: '1px',
    lineDash: ['4px']
  }
};
var guide = {
  line: {
    style: {
      stroke: '#a3a3a3',
      lineWidth: 1
    },
    offsetX: 0,
    offsetY: 0
  },
  text: {
    style: {
      fill: '#787878',
      // textAlign: 'center',
      textBaseline: 'middle'
    },
    offsetX: 0,
    offsetY: 0
  },
  rect: {
    style: {
      fill: '#fafafa'
    }
  },
  arc: {
    style: {
      stroke: '#a3a3a3'
    }
  },
  html: {
    offsetX: 0,
    offsetY: 0,
    alignX: 'center',
    alignY: 'middle'
  },
  tag: {
    offsetX: 0,
    offsetY: 0,
    side: 4,
    background: {
      padding: 5,
      radius: 2,
      fill: '#1890FF'
    },
    textStyle: {
      fontSize: 12,
      fill: '#fff',
      textAlign: 'center',
      textBaseline: 'middle'
    }
  },
  point: {
    offsetX: 0,
    offsetY: 0,
    style: {
      fill: '#fff',
      r: 3,
      lineWidth: 2,
      stroke: '#1890ff'
    }
  }
};
var chart = {
  padding: ['30px', '30px', '30px', '30px']
};
var Theme = {
  fontFamily: '"Helvetica Neue", "San Francisco", Helvetica, Tahoma, Arial, "PingFang SC", "Hiragino Sans GB", "Heiti SC", "Microsoft YaHei", sans-serif',
  pixelRatio: 1,
  padding: [0, 0, 0, 0],
  chart: chart,
  colors: ['#1890FF', '#2FC25B', '#FACC14', '#223273', '#8543E0', '#13C2C2', '#3436C7', '#F04864'],
  shapes: {
    line: ['line', 'dash', 'smooth'],
    point: ['circle', 'hollowCircle', 'rect'],
    area: ['area', 'smooth'],
    interval: ['rect', 'pyramid', 'funnel']
  },
  sizes: ['4px', '8px', '10px', '12px'],
  shape: {
    line: {
      default: {
        lineWidth: '2px',
        lineJoin: 'round',
        lineCap: 'round'
      },
      smooth: {
        smooth: true
      },
      dash: {
        lineDash: ['4px', '4px']
      }
    },
    point: {
      default: {
        lineWidth: '2px',
        size: '6px'
      }
    },
    area: {
      default: {
        fillOpacity: 0.1
      }
    },
    interval: {
      default: {}
    }
  },
  axis: axis,
  guide: guide
};
export default Theme;