import { Scale } from '@antv/scale';
import Component from '../base/component';
import InteractionMixin from '../mixins/interaction';
import Coord from '../coord';
import ScaleController from '../controller/scale';
import InteractionController from '../controller/interaction';
interface Point {
    x: number;
    y: number;
}
interface Props {
    data: any;
    scale?: any;
    coord?: any;
    start?: Point;
    end?: Point;
    children: any;
}
interface IChart {
    props: Props;
}
declare class Chart extends Component implements IChart, InteractionMixin {
    data: any;
    private layout;
    private coord;
    interaction: InteractionController;
    createInteractionController: ({ chart: any }: {
        chart: any;
    }) => any;
    setInteraction: (type: any, cfg: any) => any;
    private layoutController;
    private coordController;
    private scaleController;
    scale: ScaleController;
    constructor(props: any, context?: any, updater?: any);
    willReceiveProps(nextProps: any): void;
    willUpdate(): void;
    private getStyle;
    layoutCoord(position: any, box: any): void;
    getGeometrys(): Component<any>[];
    getSnapRecords(point: any): any;
    getLegendItems(point?: any): any;
    setScale(field: string, option: any): void;
    getScale(field: string): Scale;
    getScales(): any;
    getXScales(): any[];
    getYScales(): any[];
    getCoord(): Coord;
    render(): JSX.Element;
}
declare class ExportChart extends Chart {
}
export default ExportChart;
