"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _component = _interopRequireDefault(require("../base/component"));

var _equal = _interopRequireDefault(require("../base/equal"));

var _mixins = require("../mixins");

var _interaction = _interopRequireDefault(require("../mixins/interaction"));

var _children = _interopRequireDefault(require("../children"));

var _layout = _interopRequireDefault(require("../controller/layout"));

var _coord = _interopRequireDefault(require("../controller/coord"));

var _scale = _interopRequireDefault(require("../controller/scale"));

var _excluded = ["type"];

// 统计图表
var Chart = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Chart, _Component);

  var _super = (0, _createSuper2.default)(Chart);

  function Chart(props, context, updater) {
    var _this;

    (0, _classCallCheck2.default)(this, Chart);
    _this = _super.call(this, props, context, updater);
    var data = props.data,
        coordOption = props.coord,
        scale = props.scale,
        _props$interactions = props.interactions,
        interactions = _props$interactions === void 0 ? [] : _props$interactions;
    _this.layoutController = new _layout.default();
    _this.coordController = new _coord.default();
    _this.scaleController = new _scale.default(data);
    _this.scale = _this.scaleController;

    var _assertThisInitialize = (0, _assertThisInitialized2.default)(_this),
        layoutController = _assertThisInitialize.layoutController,
        coordController = _assertThisInitialize.coordController,
        scaleController = _assertThisInitialize.scaleController; // 布局


    var style = _this.getStyle(props, context);

    _this.layout = layoutController.create(style); // 坐标系

    _this.coord = coordController.create(coordOption, _this.layout); // scale

    scaleController.create(scale); // 创建交互事件控制器

    var interactionController = _this.createInteractionController({
      chart: (0, _assertThisInitialized2.default)(_this)
    }); // 定义事件


    interactions.forEach(function (interaction) {
      var type = interaction.type,
          cfg = (0, _objectWithoutProperties2.default)(interaction, _excluded);
      interactionController.createInteraction(type, cfg);
    });
    _this.data = data;
    _this.interaction = interactionController; // state

    _this.state = {
      zoomRange: [0, 1]
    };
    return _this;
  } // props 更新


  (0, _createClass2.default)(Chart, [{
    key: "willReceiveProps",
    value: function willReceiveProps(nextProps) {
      var layoutController = this.layoutController,
          coordController = this.coordController,
          scaleController = this.scaleController,
          lastProps = this.props;
      var nextStyle = nextProps.style,
          nextData = nextProps.data,
          nextScale = nextProps.scale,
          nextInteractions = nextProps.interactions;
      var lastStyle = lastProps.style,
          lastData = lastProps.data,
          lastScale = lastProps.scale,
          lastInteractions = lastProps.interactions; // 布局

      if (!(0, _equal.default)(nextStyle, lastStyle)) {
        var style = this.getStyle(nextProps, this.context);
        this.layout = layoutController.create(style);
        coordController.updateLayout(this.layout);
      }

      if (nextData !== lastData) {
        scaleController.changeData(nextData);
      } // scale


      if (!(0, _equal.default)(nextScale, lastScale)) {
        scaleController.update(nextScale);
      }
    }
  }, {
    key: "willUpdate",
    value: function willUpdate() {
      var coordController = this.coordController,
          props = this.props; // render 时要重置 coord 范围，重置后需要让所有子组件都重新render
      // 所以这里不比较是否有差异，每次都新建，让所有子组件重新render

      this.coord = coordController.create(props.coord, this.layout);
    }
  }, {
    key: "getStyle",
    value: function getStyle(props, context) {
      var theme = context.theme,
          px2hd = context.px2hd,
          left = context.left,
          top = context.top,
          width = context.width,
          height = context.height;
      var style = props.style;
      return px2hd((0, _objectSpread2.default)((0, _objectSpread2.default)({
        left: left,
        top: top,
        width: width,
        height: height
      }, theme.chart), style));
    }
  }, {
    key: "layoutCoord",
    value: function layoutCoord(position, box) {
      var coord = this.coord;
      var boxWidth = box.width,
          boxHeight = box.height;
      var left = coord.left,
          top = coord.top,
          width = coord.width,
          height = coord.height;

      switch (position) {
        case 'left':
          left += boxWidth;
          width = Math.max(0, width - boxWidth);
          break;

        case 'right':
          width = Math.max(0, width - boxWidth);
          break;

        case 'top':
          top += boxHeight;
          height = Math.max(0, height - boxHeight);
          break;

        case 'bottom':
          height = Math.max(0, height - boxHeight);
          break;
      }

      coord.update({
        left: left,
        top: top,
        width: width,
        height: height
      });
    }
  }, {
    key: "getGeometrys",
    value: function getGeometrys() {
      var children = this.children;
      var geometrys = [];

      _children.default.toArray(children).forEach(function (element) {
        if (!element) return false;
        var component = element.component;

        if (component && component.isGeometry) {
          geometrys.push(component);
        }
      });

      return geometrys;
    }
  }, {
    key: "getSnapRecords",
    value: function getSnapRecords(point) {
      var geometrys = this.getGeometrys();
      if (!geometrys.length) return; // @ts-ignore

      return geometrys[0].getSnapRecords(point);
    }
  }, {
    key: "getLegendItems",
    value: function getLegendItems(point) {
      var geometrys = this.getGeometrys();
      if (!geometrys.length) return; // @ts-ignore

      return geometrys[0].getLegendItems(point);
    }
  }, {
    key: "setScale",
    value: function setScale(field, option) {
      this.scaleController.setScale(field, option);
    }
  }, {
    key: "getScale",
    value: function getScale(field) {
      return this.scaleController.getScale(field);
    }
  }, {
    key: "getScales",
    value: function getScales() {
      return this.scaleController.getScales();
    }
  }, {
    key: "getXScales",
    value: function getXScales() {
      var geometrys = this.getGeometrys();
      return geometrys.map(function (component) {
        // @ts-ignore
        return component.getXScale();
      });
    }
  }, {
    key: "getYScales",
    value: function getYScales() {
      var geometrys = this.getGeometrys();
      return geometrys.map(function (component) {
        // @ts-ignore
        return component.getYScale();
      });
    }
  }, {
    key: "getCoord",
    value: function getCoord() {
      return this.coord;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = this.props,
          state = this.state,
          layout = this.layout,
          coord = this.coord;
      var children = props.children,
          data = props.data;
      return _children.default.map(children, function (child) {
        return _children.default.cloneElement(child, {
          chart: _this2,
          data: data,
          coord: coord,
          layout: layout,
          zoomRange: state.zoomRange
        });
      });
    }
  }]);
  return Chart;
}(_component.default); // 多继承


(0, _mixins.applyMixins)(Chart, [_interaction.default]);

var ExportChart = /*#__PURE__*/function (_Chart) {
  (0, _inherits2.default)(ExportChart, _Chart);

  var _super2 = (0, _createSuper2.default)(ExportChart);

  function ExportChart() {
    (0, _classCallCheck2.default)(this, ExportChart);
    return _super2.apply(this, arguments);
  }

  return (0, _createClass2.default)(ExportChart);
}(Chart);

var _default = ExportChart;
exports.default = _default;