"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _jsx = require("../../jsx");

var _component = _interopRequireDefault(require("../../base/component"));

var getPoint = function getPoint(cener, angle, r) {
  var x = cener.x + Math.cos(angle) * r;
  var y = cener.y + Math.sin(angle) * r;
  return {
    x: x,
    y: y
  };
};

var getTicks = function getTicks(start, end, tickCount) {
  var ticks = [];
  var diff = end - start;

  for (var i = 0; i <= tickCount; i++) {
    ticks.push(start + diff * i / tickCount);
  }

  return ticks;
};

var Guage = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Guage, _Component);

  var _super = (0, _createSuper2.default)(Guage);

  function Guage() {
    (0, _classCallCheck2.default)(this, Guage);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Guage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          center = _this$props.center,
          startAngle = _this$props.startAngle,
          endAngle = _this$props.endAngle,
          r = _this$props.r,
          percent = _this$props.percent,
          tickCount = _this$props.tickCount;
      var diff = endAngle - startAngle;
      var x = center.x,
          y = center.y;
      var ticks = getTicks(startAngle, endAngle, tickCount);
      return (0, _jsx.jsx)("group", null, (0, _jsx.jsx)("arc", {
        attrs: {
          x: x,
          y: y,
          r: r,
          startAngle: startAngle,
          endAngle: endAngle,
          lineWidth: '20px',
          lineCap: 'round',
          stroke: '#e7e7e7'
        }
      }), (0, _jsx.jsx)("arc", {
        attrs: {
          x: x,
          y: y,
          r: r,
          startAngle: startAngle,
          endAngle: startAngle,
          lineWidth: '40px',
          lineCap: 'round',
          stroke: '#0075ff'
        },
        animation: {
          appear: {
            easing: 'linear',
            duration: 500,
            property: ['endAngle'],
            start: {
              endAngle: startAngle
            },
            end: {
              endAngle: startAngle + diff * percent
            }
          }
        }
      }), ticks.map(function (tick) {
        var start = getPoint(center, tick, 65);
        var end = getPoint(center, tick, 75);
        return (0, _jsx.jsx)("line", {
          attrs: {
            x1: start.x,
            y1: start.y,
            x2: end.x,
            y2: end.y,
            lineWidth: '6px',
            lineCap: 'round',
            stroke: '#e7e7e7'
          }
        });
      }));
    }
  }]);
  return Guage;
}(_component.default);

var _default = Guage;
exports.default = _default;