"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _jsx = require("../../../jsx");

var _default = function _default(props) {
  var coord = props.coord,
      records = props.records;
  var center = coord.center;
  return (0, _jsx.jsx)("group", null, records.map(function (record) {
    var key = record.key,
        children = record.children;
    return (0, _jsx.jsx)("group", {
      key: key
    }, children.map(function (item) {
      var key = item.key,
          xMin = item.xMin,
          xMax = item.xMax,
          yMin = item.yMin,
          yMax = item.yMax,
          color = item.color,
          shape = item.shape;
      return (0, _jsx.jsx)("sector", {
        key: key,
        attrs: (0, _objectSpread2.default)({
          x: center.x,
          y: center.y,
          fill: color,
          startAngle: xMin,
          endAngle: xMax,
          r0: yMin,
          r: yMax
        }, shape),
        animation: {
          // appear: {
          //   easing: 'linear',
          //   duration: 450,
          //   property: ['y', 'height'],
          //   start: {
          //     y: yMax,
          //     height: 0,
          //   },
          // },
          update: {
            easing: 'linear',
            duration: 450,
            property: ['x', 'y', 'startAngle', 'endAngle', 'r0', 'r']
          }
        }
      });
    }));
  }));
};

exports.default = _default;