"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _util = require("@antv/util");

var _jsx = require("../../../jsx");

var _default = function _default(props) {
  var records = props.records,
      animation = props.animation;
  return (0, _jsx.jsx)("group", null, records.map(function (record) {
    var key = record.key,
        children = record.children;
    return (0, _jsx.jsx)("group", {
      key: key
    }, children.map(function (item) {
      var key = item.key,
          xMin = item.xMin,
          xMax = item.xMax,
          yMin = item.yMin,
          yMax = item.yMax,
          color = item.color,
          shape = item.shape;
      return (0, _jsx.jsx)("rect", {
        key: key,
        attrs: (0, _objectSpread2.default)({
          x: xMin,
          y: yMin,
          width: xMax - xMin,
          height: yMax - yMin,
          fill: color
        }, shape),
        animation: (0, _util.deepMix)({
          appear: {
            easing: 'linear',
            duration: 450,
            property: ['y', 'height'],
            start: {
              y: yMax,
              height: 0
            }
          },
          update: {
            easing: 'linear',
            duration: 450,
            property: ['x', 'y', 'width', 'height']
          }
        }, animation)
      });
    }));
  }));
};

exports.default = _default;