import Chart from '../../chart';
declare type TriggerMap = {
    [triggerType: string]: (items: any[], records: any[], legend: any) => void;
};
interface LegendItem {
    /**
     * 标记颜色。
     */
    color: string;
    /**
     * 名称。
     */
    name: string;
    /**
     * 值。
     */
    value?: string | number;
    /**
     * 图例标记。
     */
    marker?: string;
}
export interface LegendProps {
    /**
     * 代表图例对应的数据字段名。
     */
    field?: string;
    /**
     * 图表。
     */
    readonly chart?: Chart;
    /**
     * 图例的显示位置。默认为 top。
     */
    position?: 'right' | 'left' | 'top' | 'bottom';
    /**
     * 回调函数，用于格式化图例每项的文本显示。
     */
    itemFormatter?: (value: string) => string;
    /**
     * 图例项列表。
     */
    items?: LegendItem[];
    /**
     * 图例样式。
     */
    style?: any;
    /**
     * 图例标记。
     */
    marker?: 'circle' | 'square';
    /**
     * 事件触发
     */
    triggerMap?: TriggerMap;
}
declare const _default: (View: any) => {
    new (props: any): {
        maxItemWidth: number;
        willMount(): void;
        didMount(): void;
        _initItems(): void;
        _initEvent(): void;
        getItems(): any;
        setItems(items: any): void;
        getOriginItems(): any;
        getMaxItemWidth(legendShape: any): number;
        render(): JSX.Element;
        props: LegendProps;
        state: any;
        context: import("../../base/component").ComponentContext;
        refs: {
            [key: string]: any;
        };
        updater: any;
        children: JSX.Element;
        container: any;
        animate: boolean;
        willReceiveProps(_props: LegendProps): void;
        willUpdate(): void;
        didUpdate(): void; /**
         * 图例的显示位置。默认为 top。
         */
        didUnmount(): void;
        setState(partialState: any, callback?: () => void): void;
        forceUpdate(): void;
        setAnimate(animate: boolean): void;
    };
};
export default _default;
