"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _jsx = require("../../jsx");

var _diff = require("../../base/diff");

var _component = _interopRequireDefault(require("../../base/component"));

var _util = require("@antv/util");

var _default = function _default(View) {
  return /*#__PURE__*/function (_Component) {
    (0, _inherits2.default)(Legend, _Component);

    var _super = (0, _createSuper2.default)(Legend);

    function Legend(props) {
      var _this;

      (0, _classCallCheck2.default)(this, Legend);
      _this = _super.call(this, props);
      _this.state = {
        items: []
      };
      return _this;
    }

    (0, _createClass2.default)(Legend, [{
      key: "willMount",
      value: function willMount() {
        this._initItems();

        var props = this.props;
        var shape = (0, _diff.renderShape)(this, this.render(), false);

        var _shape$get = shape.get('attrs'),
            height = _shape$get.height,
            width = _shape$get.width;

        var _props$position = props.position,
            position = _props$position === void 0 ? 'top' : _props$position,
            chart = props.chart;
        var isVertical = position === 'left' || position === 'right';

        if (!isVertical) {
          chart.layoutCoord(position, {
            width: width,
            height: height
          });
          shape.remove();
          return;
        }

        var maxItemWidth = this.getMaxItemWidth(shape);
        shape.remove();
        this.maxItemWidth = maxItemWidth;
        chart.layoutCoord(position, {
          width: maxItemWidth,
          height: height
        });
      }
    }, {
      key: "didMount",
      value: function didMount() {
        this._initEvent();
      }
    }, {
      key: "_initItems",
      value: function _initItems() {
        var items = this.props.items;
        this.setState({
          items: (items === null || items === void 0 ? void 0 : items.length) ? items : this.getOriginItems()
        });
      }
    }, {
      key: "_initEvent",
      value: function _initEvent() {
        var _this2 = this;

        var context = this.context,
            props = this.props;
        var canvas = context.canvas;
        var triggerMap = props.triggerMap,
            chart = props.chart;
        if (!triggerMap) return;
        Object.keys(triggerMap).forEach(function (type) {
          canvas.on(type.toLowerCase(), function (event) {
            var points = event.points;

            var items = _this2.getOriginItems();

            var records = chart.getSnapRecords(points[0]);
            var cb = triggerMap[type];

            if ((0, _util.isFunction)(cb)) {
              cb(items, records, _this2);
            }
          });
        });
      }
    }, {
      key: "getItems",
      value: function getItems() {
        var items = this.state.items;
        return (items === null || items === void 0 ? void 0 : items.length) ? items : this.getOriginItems() || [];
      }
    }, {
      key: "setItems",
      value: function setItems(items) {
        this.setState({
          items: items
        });
      }
    }, {
      key: "getOriginItems",
      value: function getOriginItems() {
        var chart = this.props.chart;
        return chart.getLegendItems();
      }
    }, {
      key: "getMaxItemWidth",
      value: function getMaxItemWidth(legendShape) {
        var maxItemWidth = 0;
        (legendShape.get('children') || []).forEach(function (child) {
          var childWidth = child.getBBox().width;

          if (childWidth > maxItemWidth) {
            maxItemWidth = childWidth;
          }
        });
        return maxItemWidth;
      }
    }, {
      key: "render",
      value: function render() {
        var props = this.props,
            maxItemWidth = this.maxItemWidth,
            context = this.context;
        var width = context.width;
        var items = this.getItems();
        return (0, _jsx.jsx)(View, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props), {}, {
          items: items,
          maxItemWidth: maxItemWidth || width
        }));
      }
    }]);
    return Legend;
  }(_component.default);
};

exports.default = _default;