"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _jsx = require("../../jsx");

var _component = _interopRequireDefault(require("../../base/component"));

var _util = require("@antv/util");

var _default = function _default(View) {
  return /*#__PURE__*/function (_Component) {
    (0, _inherits2.default)(Tooltip, _Component);

    var _super = (0, _createSuper2.default)(Tooltip);

    function Tooltip(props) {
      var _this;

      (0, _classCallCheck2.default)(this, Tooltip);
      _this = _super.call(this, props);
      _this.state = {
        records: null
      };
      return _this;
    }

    (0, _createClass2.default)(Tooltip, [{
      key: "didMount",
      value: function didMount() {
        this._initEvent();
      }
    }, {
      key: "_initEvent",
      value: function _initEvent() {
        var _this2 = this;

        var context = this.context,
            props = this.props;
        var canvas = context.canvas;
        var _props$triggerOn = props.triggerOn,
            triggerOn = _props$triggerOn === void 0 ? 'press' : _props$triggerOn,
            _props$triggerOff = props.triggerOff,
            triggerOff = _props$triggerOff === void 0 ? 'pressend' : _props$triggerOff,
            _props$alwaysShow = props.alwaysShow,
            alwaysShow = _props$alwaysShow === void 0 ? false : _props$alwaysShow;
        canvas.on(triggerOn, function (ev) {
          var points = ev.points;

          _this2.show(points[0]);
        });
        canvas.on(triggerOff, function (_ev) {
          if (!alwaysShow) {
            _this2.hide();
          }
        });
      }
    }, {
      key: "show",
      value: function show(point) {
        var props = this.props;
        var chart = props.chart,
            onChange = props.onChange;
        var records = chart.getSnapRecords(point);
        this.setState({
          records: records
        });

        if ((0, _util.isFunction)(onChange)) {
          onChange(records);
        }
      }
    }, {
      key: "hide",
      value: function hide() {
        this.setState({
          records: null
        });
      }
    }, {
      key: "render",
      value: function render() {
        var props = this.props,
            state = this.state;
        var visible = props.visible;

        if (visible === false) {
          return null;
        }

        return (0, _jsx.jsx)(View, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props), state));
      }
    }]);
    return Tooltip;
  }(_component.default);
};

exports.default = _default;