"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _util = require("@antv/util");

var _context = _interopRequireDefault(require("./interaction/context"));

var defaultInteractions = _interopRequireWildcard(require("./interaction/index"));

var interactionController = /*#__PURE__*/function () {
  function interactionController(chart) {
    (0, _classCallCheck2.default)(this, interactionController);
    this.chart = chart;
    this.interactions = [];
  }

  (0, _createClass2.default)(interactionController, [{
    key: "createInteraction",
    value: function createInteraction(type, cfg) {
      if (!type) {
        return null;
      }

      if (!this.context) {
        this.context = new _context.default(this.chart);
      }

      var Constructor = defaultInteractions[(0, _util.upperFirst)(type)];

      if (!type || !Constructor) {
        return;
      }

      var chart = this.chart,
          context = this.context;
      var interaction = new Constructor(cfg, {
        chart: chart,
        context: context
      });
      this.interactions.push(interaction);
    }
  }, {
    key: "getInteractionContext",
    value: function getInteractionContext() {
      if (!this.context) {
        this.context = new _context.default(this.chart);
      }

      return this.context;
    }
  }]);
  return interactionController;
}();

exports.default = interactionController;