"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _util = require("@antv/util");

// 定义start / end 等
var Base = /*#__PURE__*/function () {
  function Base(cfg, _ref) {
    var _this = this;

    var chart = _ref.chart,
        context = _ref.context;
    (0, _classCallCheck2.default)(this, Base);
    this.type = '';
    this.startEvent = 'touchstart';
    this.processEvent = 'touchmove';
    this.endEvent = 'touchend';
    this.resetEvent = null; // 交互的上下文

    this.context = null;

    this._start = function (ev) {
      _this.preStart && _this.preStart(ev);

      _this.start(ev);

      _this.onStart && _this.onStart(ev);
    };

    this._process = function (ev) {
      _this.preProcess && _this.preProcess(ev);

      _this.process(ev);

      _this.onProcess && _this.onProcess(ev);
    };

    this._end = function (ev) {
      _this.preEnd && _this.preEnd(ev);

      _this.end(ev);

      _this.onEnd && _this.onEnd(ev);
    };

    this._reset = function (ev) {
      _this.preReset && _this.preReset(ev);

      _this.reset(ev);

      _this.onReset && _this.onReset(ev);
    };

    (0, _util.mix)(this, this.getDefaultCfg(), cfg);
    this.context = context;
    this.chart = chart; // 只处理range, 暂时先这么处理后面再看情况调整

    var range = this.range;

    if (range) {
      this.context.range = range;
    }

    this._bindEvents(chart);
  }

  (0, _createClass2.default)(Base, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {};
    }
  }, {
    key: "_bindEvents",
    value: function _bindEvents(_chart) {
      var startEvent = this.startEvent,
          processEvent = this.processEvent,
          endEvent = this.endEvent,
          resetEvent = this.resetEvent;
      var canvas = this.context.canvas; // 统一绑定事件

      canvas.on(startEvent, this._start);
      canvas.on(processEvent, this._process);
      canvas.on(endEvent, this._end);
      canvas.on(resetEvent, this._reset);
    }
  }, {
    key: "_clearEvents",
    value: function _clearEvents() {
      var startEvent = this.startEvent,
          processEvent = this.processEvent,
          endEvent = this.endEvent,
          resetEvent = this.resetEvent;
      var canvas = this.context.canvas; // 统一解绑事件

      canvas.off(startEvent, this._start);
      canvas.off(processEvent, this._process);
      canvas.off(endEvent, this._end);
      canvas.off(resetEvent, this._start);
    } // override

  }, {
    key: "start",
    value: function start(_ev) {} // override

  }, {
    key: "process",
    value: function process(_ev) {} // override

  }, {
    key: "end",
    value: function end(_ev) {} // override

  }, {
    key: "reset",
    value: function reset(_pev) {}
  }, {
    key: "destroy",
    value: function destroy() {
      this.context.destroy();

      this._clearEvents();
    }
  }]);
  return Base;
}();

exports.default = Base;