"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _base = _interopRequireDefault(require("./base"));

var _util = require("@antv/util");

/**
 * 缩放
 */
var Pinch = /*#__PURE__*/function (_Base) {
  (0, _inherits2.default)(Pinch, _Base);

  var _super = (0, _createSuper2.default)(Pinch);

  function Pinch(cfg, chart) {
    var _this;

    (0, _classCallCheck2.default)(this, Pinch);
    _this = _super.call(this, cfg, chart);

    var _assertThisInitialize = (0, _assertThisInitialized2.default)(_this),
        context = _assertThisInitialize.context;

    (0, _util.mix)(context, cfg);
    return _this;
  }

  (0, _createClass2.default)(Pinch, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        type: 'pinch',
        startEvent: 'pinchstart',
        processEvent: 'pinch',
        endEvent: 'pinchend'
      };
    }
  }, {
    key: "start",
    value: function start() {
      var context = this.context;
      context.start();
    }
  }, {
    key: "process",
    value: function process(e) {
      e.preventDefault && e.preventDefault();
      var zoom = e.zoom,
          center = e.center;
      var context = this.context;
      var chart = context.chart;
      var coord = chart.coord;
      var start = coord.start,
          end = coord.end;
      var coordWidth = end.x - start.x;
      var leftLen = Math.abs(center.x - start.x);
      var rightLen = Math.abs(end.x - center.x); // 计算左右缩放的比例

      var leftScale = leftLen / coordWidth;
      var rightScale = rightLen / coordWidth;
      context.doZoom(leftScale, rightScale, zoom);
    }
  }, {
    key: "end",
    value: function end() {
      // 缩放完成后再更新ticks
      var context = this.context;
      context.repaint();
    }
  }]);
  return Pinch;
}(_base.default);

exports.default = Pinch;